<?php

$page = "browse_confessions";
include "header.php";

// DISPLAY ERROR PAGE IF USER IS NOT LOGGED IN AND ADMIN SETTING REQUIRES REGISTRATION
if( !$user->user_exists && !$setting['setting_permission_confession'] )
{
  $page = "error";
  $smarty->assign('error_header', 639);
  $smarty->assign('error_message', 656);
  $smarty->assign('error_submit', 641);
  include "footer.php";
}


// PARSE GET/POST
if(isset($_POST['p'])) { $p = $_POST['p']; } elseif(isset($_GET['p'])) { $p = $_GET['p']; } else { $p = 1; }
if(isset($_POST['s'])) { $s = $_POST['s']; } elseif(isset($_GET['s'])) { $s = $_GET['s']; } else { $s = "confession_datecreated DESC"; }
if(isset($_POST['v'])) { $v = $_POST['v']; } elseif(isset($_GET['v'])) { $v = $_GET['v']; } else { $v = 0; }
if(isset($_POST['confessioncat_id'])) { $confessioncat_id = $_POST['confessioncat_id']; } elseif(isset($_GET['confessioncat_id'])) { $confessioncat_id = $_GET['confessioncat_id']; } else { $confessioncat_id = 0; }
if(isset($_POST['confession_search'])) { $confession_search = $_POST['confession_search']; } elseif(isset($_GET['confession_search'])) { $confession_search = $_GET['confession_search']; } else { $confession_search = NULL; }

// ENSURE SORT/VIEW ARE VALID
if($s != "confession_date DESC" && $s != "confession_dateupdated DESC" && $s != "confession_views DESC" && $s != "total_comments DESC") { $s = "confession_date DESC"; }
if($v != "0" && $v != "1") { $v = 0; }


// SET WHERE CLAUSE
$where = "CASE
	    WHEN se_confessions.confession_user_id='{$user->user_info['user_id']}'
	      THEN TRUE
	    WHEN ((se_confessions.confession_privacy & @SE_PRIVACY_REGISTERED) AND '{$user->user_exists}'<>0)
	      THEN TRUE
	    WHEN ((se_confessions.confession_privacy & @SE_PRIVACY_ANONYMOUS) AND '{$user->user_exists}'=0)
	      THEN TRUE
	    WHEN ((se_confessions.confession_privacy & @SE_PRIVACY_FRIEND) AND '{$user->user_exists}'<>0 AND (SELECT TRUE FROM se_friends WHERE friend_user_id1=se_confessions.confession_user_id AND friend_user_id2='{$user->user_info['user_id']}' AND friend_status='1' LIMIT 1))
	      THEN TRUE
	    WHEN ((se_confessions.confession_privacy & @SE_PRIVACY_SUBNET) AND '{$user->user_exists}'<>0 AND (SELECT TRUE FROM se_users WHERE user_id=se_confessions.confession_user_id AND user_subnet_id='{$user->user_info['user_subnet_id']}' LIMIT 1))
	      THEN TRUE
	    WHEN ((se_confessions.confession_privacy & @SE_PRIVACY_FRIEND2) AND '{$user->user_exists}'<>0 AND (SELECT TRUE FROM se_friends AS friends_primary LEFT JOIN se_users ON friends_primary.friend_user_id1=se_users.user_id LEFT JOIN se_friends AS friends_secondary ON friends_primary.friend_user_id2=friends_secondary.friend_user_id1 WHERE friends_primary.friend_user_id1=se_confessions.confession_user_id AND friends_secondary.friend_user_id2='{$user->user_info['user_id']}' AND se_users.user_subnet_id='{$user->user_info['user_subnet_id']}' LIMIT 1))
	      THEN TRUE
	    ELSE FALSE
	END";



// ONLY MY FRIENDS' confessionS
if( $v=="1" && $user->user_exists )
{
  // SET WHERE CLAUSE
  $where .= " AND (SELECT TRUE FROM se_friends WHERE friend_user_id1='{$user->user_info['user_id']}' AND friend_user_id2=se_confessions.confession_user_id AND friend_status=1)";
}



// SPECIFIC confession CATEGORY
if( $confessioncat_id )
{
  $sql = "SELECT confessioncat_id, confessioncat_title, confessioncat_dependency FROM se_confessioncats WHERE confessioncat_id={$confessioncat_id} LIMIT 1";
  $resource = $database->database_query($sql) or die("<b>Error: </b>".$database->database_error()."<br /><b>File: </b>".__FILE__."<br /><b>Line: </b>".__LINE__."<br /><b>Query: </b>".$sql);
  
  if( $database->database_num_rows($resource) )
  {
    $confessioncat = $database->database_fetch_assoc($resource);
    
    if( !$confessioncat['confessioncat_dependency'] )
    {
      $cat_ids[] = $confessioncat['confessioncat_id'];
      $depcats = $database->database_query("SELECT confessioncat_id FROM se_confessioncats WHERE confessioncat_id='{$confessioncat['confessioncat_id']}' OR confessioncat_dependency='{$confessioncat['confessioncat_id']}'");
      while($depcat_info = $database->database_fetch_assoc($depcats)) { $cat_ids[] = $depcat_info['confessioncat_id']; }
      $where .= " AND se_confessions.confession_confessioncat_id IN('".implode("', '", $cat_ids)."')";
    }
    else
    {
      $where .= " AND se_confessions.confession_confessioncat_id='{$confessioncat['confessioncat_id']}'";
      $confessionsubcat = $confessioncat;
      $confessioncat = $database->database_fetch_assoc($database->database_query("SELECT confessioncat_id, confessioncat_title FROM se_confessioncats WHERE confessioncat_id='{$confessioncat['confessioncat_dependency']}'"));
    }
  }
}


// GET CATS
$field = new se_field("confession");
$field->cat_list(0, 0, 0, "", "", "");
$cat_menu_array = $field->cats;

//$field->cat_list(0, 0, 1, "confessioncat_id='{$confessioncat['confessioncat_id']}'", "", "");
$field->field_list(0, 0, 1, "confessionfield_confessioncat_id='{$confessioncat['confessioncat_id']}' && confessionfield_search<>'0'");


// BEGIN CONSTRUCTING SEARCH QUERY
//echo $field->field_query;
if( $field->field_query )
  $where .= " && ".$field->field_query;

if( !empty($confession_search) )
{
  $where .= " && MATCH(confession_title, confession_body) AGAINST ('{$confession_search}' IN BOOLEAN MODE) ";
}


// CREATE confession OBJECT, GET TOTAL confessionS, MAKE ENTRY PAGES, GET confession ARRAY
$confession = new se_confession();

$total_confessions = $confession->confession_total($where, TRUE);
$confessions_per_page = 10;
$page_vars = make_page($total_confessions, $confessions_per_page, $p);

$confession_array = $confession->confession_list($page_vars[0], $confessions_per_page, $s, $where, TRUE);




// ASSIGN SMARTY VARIABLES AND DISPLAY confessionS PAGE
$smarty->assign('confessioncat_id', $confessioncat_id);
$smarty->assign('confessioncat', $confessioncat);
$smarty->assign('confessionsubcat', $confessionsubcat);
$smarty->assign('confession_search', $confession_search);

$smarty->assign_by_ref('cats_menu', $cat_menu_array);
$smarty->assign_by_ref('cats', $field->cats);
$smarty->assign_by_ref('fields', $field->fields);
$smarty->assign_by_ref('url_string', $field->url_string);

$smarty->assign('confessions', $confession_array);
$smarty->assign('total_confessions', $total_confessions);
$smarty->assign('p', $page_vars[1]);
$smarty->assign('maxpage', $page_vars[2]);
$smarty->assign('p_start', $page_vars[0]+1);
$smarty->assign('p_end', $page_vars[0]+count($confession_array));
$smarty->assign('s', $s);
$smarty->assign('v', $v);
include "footer.php";
?>