<?php

// ENSURE THIS IS BEING INCLUDED IN AN SE SCRIPT
defined('SE_PAGE') or exit();

// INCLUDE confessionS CLASS FILE
include "./include/class_confession.php";

// INCLUDE confessionS FUNCTION FILE
include "./include/functions_confession.php";

// PRELOAD LANGUAGE
SE_Language::_preload(8700007);

// SET MAIN MENU VARS
if( ($user->user_exists && $user->level_info['level_confession_allow']) || (!$user->user_exists && $setting['setting_permission_confession']) )
{
  $plugin_vars['menu_main'] = array('file' => 'browse_confessions.php', 'title' => 8700007);
}

// SET USER MENU VARS
if( ($user->user_exists && $user->level_info['level_confession_allow']) )
{
  $plugin_vars['menu_user'] = array('file' => 'user_confession.php', 'icon' => 'confession_confession16.gif', 'title' => 8700007);
}

// SET PROFILE MENU VARS
if( $owner->level_info['level_confession_allow'] && $page=="profile" )
{
  // START confession
  $confession = new se_confession($owner->user_info['user_id']);
  $listings_per_page = 5;
  $sort = "confession_date DESC";

  // GET PRIVACY LEVEL AND SET WHERE
  $privacy_max = $owner->user_privacy_max($user);
  $where = "(confession_privacy & $privacy_max)";

  // GET TOTAL LISTINGS
  $total_confessions = $confession->confession_total($where);

  // GET LISTING ARRAY
  $confessions = $confession->confession_list(0, $listings_per_page, $sort, $where);

  // ASSIGN ENTRIES SMARY VARIABLE
  $smarty->assign_by_ref('confessions', $confessions);
  $smarty->assign('total_confessions', $total_confessions);
  
  //print_r($confessions);
  
  // SET PROFILE MENU VARS
  if( $total_confessions )
  {
    $plugin_vars['menu_profile_tab'] = array('file'=> 'profile_confession.tpl', 'title' => 8700007);
    $plugin_vars['menu_profile_side'] = "";
  }
}



// SET HOOKS
SE_Hook::register("se_search_do", 'search_confession');

SE_Hook::register("se_user_delete", 'deleteuser_confession');

SE_Hook::register("se_site_statistics", 'site_statistics_confession');

?>