<?php

defined('SE_PAGE') or exit();


class se_confession
{
	// INITIALIZE VARIABLES
	var $is_error;				            // DETERMINES WHETHER THERE IS AN ERROR OR NOT
	var $error_message;			          // CONTAINS RELEVANT ERROR MESSAGE

	var $user_id;				              // CONTAINS THE USER ID OF THE USER WHOSE confession WE ARE EDITING

	var $confession_exists;			      // DETERMINES WHETHER THE confession HAS BEEN SET AND EXISTS OR NOT

	var $confession_info;			        // CONTAINS THE confession INFO OF THE confession WE ARE EDITING
	var $confessionvalue_info;	      // CONTAINS THE confession FIELD VALUE INFO
	var $confessionowner_level_info;	// CONTAINS THE confession CREATOR'S LEVEL INFO

	var $url_string;		              // CONTAINS VARIOUS PARTIAL URL STRINGS (SITUATION DEPENDENT)
  
  
  
  
  
  

  
  //
	// THIS METHOD SETS INITIAL VARS
  //
	// INPUT:
  //    $user_id (OPTIONAL) REPRESENTING THE USER ID OF THE USER WHOSE confession WE ARE CONCERNED WITH
  //
	// OUTPUT: 
  //
  
	function se_confession($user_id=NULL, $confession_id=NULL)
  {
	  global $database, $user, $owner;
    
	  $this->user_id = $user_id;
	  $this->confession_exists = FALSE;
	  $this->is_member = FALSE;
    
	  if( $confession_id )
    {
      $sql = "SELECT * FROM se_confessions WHERE confession_id='{$confession_id}' LIMIT 1";
      $resource = $database->database_query($sql);
      
	    if( $database->database_num_rows($resource) )
      {
	      $this->confession_exists = TRUE;
	      $this->confession_info = $database->database_fetch_assoc($resource);
        
        $sql = "SELECT * FROM se_confessionvalues WHERE confessionvalue_confession_id='{$confession_id}' LIMIT 1";
        $resource = $database->database_query($sql);
        
        if( $database->database_num_rows($resource) )
          $this->confessionvalue_info = $database->database_fetch_assoc($resource);
        
	      // GET LEVEL INFO
	      if( $this->confession_info['confession_user_id']==$user->user_info['user_id'] )
	        $this->confessionowner_level_info =& $user->level_info;
        elseif( $this->confession_info['confession_user_id']==$owner->user_info['user_id'] )
	        $this->confessionowner_level_info =& $owner->level_info;
        
        if( !$this->confessionowner_level_info )
        {
          $sql = "SELECT se_levels.* FROM se_users LEFT JOIN se_levels ON se_users.user_level_id=se_levels.level_id WHERE se_users.user_id='{$this->confession_info['confession_user_id']}' LIMIT 1";
          $resource = $database->database_query($sql);
          
          if( $database->database_num_rows($resource) )
            $this->confessionowner_level_info = $database->database_fetch_assoc($resource);
	      }
	    }
	  }
	}
  
  // END se_confession() METHOD
  
  
  
  
  
  
  
  
	//
  // THIS METHOD RETURNS THE TOTAL NUMBER OF ENTRIES
	//
  // INPUT:
  //    $where                (OPTIONAL) REPRESENTING ADDITIONAL THINGS TO INCLUDE IN THE WHERE CLAUSE
	//	  $confession_details   (OPTIONAL) REPRESENTING WHETHER TO RETRIEVE THE VALUES FROM confessionVALUES TABLE AS WELL
  //
	// OUTPUT:
  //    AN INTEGER REPRESENTING THE NUMBER OF ENTRIES
  //
  
	function confession_total($where=NULL, $confession_details=FALSE)
  {
	  global $database;
    
	  // BEGIN ENTRY QUERY
	  $sql = "
      SELECT
        NULL
      FROM
        se_confessions
    ";
    
	  // IF NO USER ID SPECIFIED, JOIN TO USER TABLE
	  if( !$this->user_id ) $sql .= "
      LEFT JOIN
        se_users
        ON se_confessions.confession_user_id=se_users.user_id
    ";
    
	  // IF confession DETAILS
	  if( $confession_details ) $sql .= "
      LEFT JOIN
        se_confessionvalues
        ON se_confessions.confession_id=se_confessionvalues.confessionvalue_confession_id
    ";
    
	  // ADD WHERE IF NECESSARY
	  if( !empty($where) || $this->user_id ) $sql .= "
      WHERE
    ";
    
	  // ENSURE USER ID IS NOT EMPTY
	  if( $this->user_id ) $sql .= "
        se_confessions.confession_user_id='{$this->user_id}'
    ";
    
	  // INSERT AND IF NECESSARY
	  if( $this->user_id && !empty($where) ) $sql .= " AND ";
    
	  // ADD WHERE CLAUSE, IF NECESSARY
	  if( !empty($where) ) $sql .= "
        $where
    ";
    
	  // GET AND RETURN TOTAL confession ENTRIES
	  $resource = $database->database_query($sql);
	  $confession_total = $database->database_num_rows($resource);
    
	  return $confession_total;
	}
  
  // END confessions_total() METHOD
  
  
  
  
  
  
  
  
  //
	// THIS METHOD RETURNS AN ARRAY OF confession ENTRIES
  //
	// INPUT:
  //    $start                REPRESENTING THE ENTRY TO START WITH
	//	  $limit                REPRESENTING THE NUMBER OF ENTRIES TO RETURN
	//	  $sort_by              (OPTIONAL) REPRESENTING THE ORDER BY CLAUSE
	//	  $where                (OPTIONAL) REPRESENTING ADDITIONAL THINGS TO INCLUDE IN THE WHERE CLAUSE
	//	  $confession_details   (OPTIONAL) REPRESENTING WHETHER TO RETRIEVE THE VALUES FROM confessionVALUES TABLE AS WELL
  //
	// OUTPUT:
  //    AN ARRAY OF confession ENTRIES
  //
  
	function confession_list($start, $limit, $sort_by="confession_date DESC", $where=NULL, $confession_details=FALSE)
  {
	  global $database, $user, $owner;
    
	  // BEGIN QUERY
	  $sql = "
      SELECT
        se_confessions.*,
        main_category.confessioncat_id AS main_category_id,
        main_category.confessioncat_title AS main_category_title,
        parent_category.confessioncat_id AS parent_category_id,
        parent_category.confessioncat_title AS parent_category_title,
        se_confessions.confession_totalcomments AS total_comments
    ";
    
	  // IF NO USER ID SPECIFIED, RETRIEVE USER INFORMATION
	  if( !$this->user_id ) $sql .= ",
        se_users.user_id,
        se_users.user_username,
        se_users.user_photo,
        se_users.user_fname,
        se_users.user_lname
    ";
    
	  // IF confession DETAILS
    if( $confession_details ) $sql .= ",
        se_confessionvalues.*
    ";
    
	  // CONTINUE QUERY
	  $sql .= " 
      FROM
        se_confessions
      LEFT JOIN
        se_confessioncats AS main_category
        ON main_category.confessioncat_id=se_confessions.confession_confessioncat_id
      LEFT JOIN
        se_confessioncats AS parent_category
        ON parent_category.confessioncat_id=main_category.confessioncat_dependency
    ";
    
	  // IF NO USER ID SPECIFIED, JOIN TO USER TABLE
	  if( !$this->user_id ) $sql .= "
      LEFT JOIN
        se_users
        ON se_confessions.confession_user_id=se_users.user_id
    ";
    
	  // IF confession DETAILS
	  if( $confession_details ) $sql .= "
      LEFT JOIN
        se_confessionvalues
        ON se_confessions.confession_id=se_confessionvalues.confessionvalue_confession_id
    ";
    
	  // ADD WHERE IF NECESSARY
	  if( !empty($where) || $this->user_id ) $sql .= "
      WHERE
    ";
    
	  // ENSURE USER ID IS NOT EMPTY
	  if( $this->user_id ) $sql .= "
        confession_user_id='{$this->user_id}'
    ";
    
	  // INSERT AND IF NECESSARY
	  if( $this->user_id && !empty($where) )
      $sql .= " AND";
    
	  // ADD WHERE CLAUSE, IF NECESSARY
	  if( !empty($where) ) $sql .= "
      $where
    ";
    
	  // ADD GROUP BY, ORDER, AND LIMIT CLAUSE
	  $sql .= "
    /*
      GROUP BY
        confession_id */
      ORDER BY
        $sort_by
      LIMIT
        $start, $limit
    ";
    
	  // RUN QUERY
	  $resource = $database->database_query($sql);
    
	  // GET confession ENTRIES INTO AN ARRAY
	  $confession_array = array();
	  while( $confession_info=$database->database_fetch_assoc($resource) )
    {
	    // CONVERT HTML CHARACTERS BACK
	    $confession_info['confession_body'] = str_replace("\r\n", "", html_entity_decode($confession_info['confession_body']));
      
	    // IF NO USER ID SPECIFIED, CREATE OBJECT FOR AUTHOR
	    if( !$this->user_id )
      {
	      $author = new se_user();
	      $author->user_exists = 1;
	      $author->user_info['user_id']       = $confession_info['user_id'];
	      $author->user_info['user_username'] = $confession_info['user_username'];
	      $author->user_info['user_photo']    = $confession_info['user_photo'];
	      $author->user_info['user_fname']    = $confession_info['user_fname'];
	      $author->user_info['user_lname']    = $confession_info['user_lname'];
	      $author->user_displayname();
      }
      
	    // OTHERWISE, SET AUTHOR TO OWNER/LOGGED-IN USER
	    elseif( $owner->user_exists && $owner->user_info['user_id']==$confession_info['confession_user_id'] )
      {
	      $author =& $owner;
	    }
      elseif( $user->user_exists && $user->user_info['user_id']==$confession_info['confession_user_id'] )
      {
	      $author =& $user;
	    }
      else
      {
        $author = new se_user(array($confession_info['confession_user_id']));
      }
      
	    // GET ENTRY COMMENT PRIVACY
      // FIND A WAY TO MAKE THIS WORK WITH THE AUTHOR
	    $allowed_to_comment = TRUE;
	    if( $owner->user_exists )
      {
	      $comment_level = $owner->user_privacy_max($user);
	      if( !($comment_level & $confession_info['confession_comments']) )
          $allowed_to_comment = FALSE;
	    }
      
      // PRELOAD CATEGORY TITLE
      if( $confession_info['main_category_title'] )
        SE_Language::_preload($confession_info['main_category_title']);
        
      if( $confession_info['parent_category_title'] )
        SE_Language::_preload($confession_info['parent_category_title']);
      
	    // CREATE OBJECT FOR confession
	    $confession = new se_confession($confession_info['user_id']);
	    $confession->confession_exists = TRUE;
	    $confession->confession_info = $confession_info;
      
	    // SET confession ARRAY
	    $confession_array[] = array
      (
        'confession'                      => &$confession,
        'confession_author'               => &$author,
        'total_comments'                  => $confession_info['total_comments'],
        'allowed_to_comment'              => $allowed_to_comment
      );
      
      unset($author, $confession);
	  }
    
	  // RETURN ARRAY
	  return $confession_array;
	}
  
  // END confessions_list() METHOD
  
  
  
  
  
  
  
  
  //
	// THIS METHOD POSTS/EDITS AN ENTRY
  //
	// INPUT:
  //    $confession_id                REPRESENTING THE ID OF THE confession ENTRY TO EDIT. IF NO ENTRY WITH THIS ID IS FOUND, A NEW ENTRY WILL BE ADDED
	//	  $confession_title             REPRESENTING THE TITLE OF THE confession ENTRY
	//	  $confession_body              REPRESENTING THE BODY OF THE confession ENTRY
	//	  $confession_confessioncat_id  REPRESENTING THE ID OF THE SELECTED confession ENTRY CATEGORY
	//	  $confession_search            REPRESENTING WHETHER THE confession ENTRY SHOULD BE INCLUDED IN SEARCH RESULTS
	//	  $confession_privacy           REPRESENTING THE PRIVACY LEVEL OF THE ENTRY
	//	  $confession_comments          REPRESENTING WHO CAN COMMENT ON THE ENTRY
	//	  $confession_field_query       REPRESENTING THE PARTIAL QUERY TO SAVE IN THE confession'S VALUE TABLE
  //
	// OUTPUT:
  //
  
	function confession_post($confession_id=NULL, $confession_title, $confession_body, $confession_confessioncat_id, $confession_search, $confession_privacy, $confession_comments, $confession_field_query)
  {
	  global $database, $user;
    
    // INIT VARS
	  $confession_date = time();
	  $confession_title = censor($confession_title);
	  $confession_body = censor(htmlspecialchars_decode($confession_body));
	  $confession_body = cleanHTML($confession_body, $user->level_info['level_confession_html']);
	  $confession_body = security($confession_body);
    
    
    // UPDATE TABLE ROW
    if( $confession_id )
    {
      $sql = "
        UPDATE
          se_confessions
        SET
          confession_confessioncat_id='{$confession_confessioncat_id}',
          confession_dateupdated='{$confession_date}',
          confession_title='{$confession_title}',
          confession_body='{$confession_body}',
          confession_search='{$confession_search}',
          confession_privacy='{$confession_privacy}',
          confession_comments='{$confession_comments}'
        WHERE
          confession_id='{$confession_id}' &&
          confession_user_id='{$this->user_id}'
        LIMIT
          1
      ";
      
      $database->database_query($sql);
    }
    
    // ADD TABLE ROW
    else
    {
      $sql = "
        INSERT INTO se_confessions (
          confession_user_id,
          confession_confessioncat_id,
          confession_date,
          confession_dateupdated,
          confession_title,
          confession_body,
          confession_search,
          confession_privacy,
          confession_comments
        ) VALUES (
          '{$this->user_id}',
          '{$confession_confessioncat_id}',
          '{$confession_date}',
          '{$confession_date}',
          '{$confession_title}',
          '{$confession_body}',
          '{$confession_search}',
          '{$confession_privacy}',
          '{$confession_comments}'
        )
      ";
      
      $database->database_query($sql);
      $confession_id = $database->database_insert_id();
      
      // ADD confession FIELD VALUE ROW
      $sql = "INSERT INTO se_confessionvalues (confessionvalue_confession_id) VALUES ('{$confession_id}')";
      $database->database_query($sql);
      
      // ADD confession ALBUM
      $sql = "
        INSERT INTO se_confessionalbums (
          confessionalbum_confession_id,
          confessionalbum_datecreated,
          confessionalbum_dateupdated,
          confessionalbum_title,
          confessionalbum_desc,
          confessionalbum_search,
          confessionalbum_privacy,
          confessionalbum_comments
        ) VALUES (
          '{$confession_id}',
          '{$confession_date}',
          '{$confession_date}',
          '',
          '',
          '{$confession_search}',
          '{$confession_privacy}',
          '{$confession_comments}'
        )
      ";
      $database->database_query($sql);
    }
    
    // UPDATE confession FIELD VALUES
    if( !empty($confession_field_query) )
    {
      $sql = "UPDATE se_confessionvalues SET {$confession_field_query} WHERE confessionvalue_confession_id='{$confession_id}' LIMIT 1";
      $database->database_query($sql);
    }
    
    // CHECK AND ADD confession DIRECTORY
    $confession_directory = $this->confession_dir($confession_id);
    $confession_path_array = explode("/", $confession_directory);
    array_pop($confession_path_array);
    array_pop($confession_path_array);
    $subdir = implode("/", $confession_path_array)."/";
    
    if( !is_dir($subdir) )
    { 
      mkdir($subdir, 0777); 
      chmod($subdir, 0777); 
      $handle = fopen($subdir."index.php", 'x+');
      fclose($handle);
    }
    
    if( !is_dir($confession_directory) )
    {
      mkdir($confession_directory, 0777);
      chmod($confession_directory, 0777);
      $handle = fopen($confession_directory."/index.php", 'x+');
      fclose($handle);
    }
    
	  return $confession_id;
	}
  
  // END confession_post() METHOD
  
  
  
  
  
  
  
  
  //
	// THIS METHOD DELETES confession ENTRIES
  //
	// INPUT:
  //    $confession_id  REPRESENTING THE ID OF THE ENTRY TO DELETE
  //
	// OUTPUT:
  //
  
	function confession_delete($confession_id=NULL)
  {
	  global $database;
    
    // IF EMPTY, TRY TO GET FROM OBJECT
	  if( !$confession_id && !$this->confession_exists )
      return FALSE;
    elseif( !$confession_id )
      $confession_id = $this->confession_info['confession_id'];
    
    // IF ARRAY
    if( is_array($confession_id) )
      return array_map(array(&$this, 'confession_delete'), $confession_id);
    
	  // DELETE confession ALBUM AND MEDIA
    $sql = "DELETE FROM se_confessionalbums, se_confessionmedia USING se_confessionalbums LEFT JOIN se_confessionmedia ON se_confessionalbums.confessionalbum_id=se_confessionmedia.confessionmedia_confessionalbum_id WHERE se_confessionalbums.confessionalbum_confession_id='{$confession_id}'";
	  $database->database_query($sql);
    
	  // DELETE confession VALUES
	  $sql = "DELETE FROM se_confessionvalues WHERE se_confessionvalues.confessionvalue_confession_id='{$confession_id}' LIMIT 1";
    $database->database_query($sql);
    
	  // DELETE confession ROW
	  $sql = "DELETE FROM se_confessions WHERE se_confessions.confession_id='{$confession_id}' LIMIT 1";
    $database->database_query($sql);
    
	  // DELETE confession COMMENTS
	  $sql = "DELETE FROM se_confessioncomments WHERE se_confessioncomments.confessioncomment_confession_id='{$confession_id}'";
    $database->database_query($sql);
    
	  // DELETE confession'S FILES
	  if( is_dir($this->confession_dir($confession_id)) )
	    $dir = $this->confession_dir($confession_id);
	  else
	    $dir = ".".$this->confession_dir($confession_id);
    
	  if( $dh = @opendir($dir) )
    {
	    while( ($file = @readdir($dh))!==FALSE )
	      if($file != "." & $file != "..")
	        @unlink($dir.$file);
      
	    @closedir($dh);
	  }
	  @rmdir($dir);
    
    return TRUE;
	}
  
  // END confession_delete() METHOD
  
  
  
  
  
  
  
  
  //
	// THIS METHOD RETURNS THE PATH TO THE GIVEN confession'S DIRECTORY
  //
	// INPUT:
  //    $confession_id (OPTIONAL) REPRESENTING A confession'S confession
  //
	// OUTPUT:
  //    A STRING REPRESENTING THE RELATIVE PATH TO THE confession'S DIRECTORY
  //
  
	function confession_dir($confession_id=NULL)
  {
	  if( !$confession_id && $this->confession_exists )
      $confession_id = $this->confession_info['confession_id'];
    
	  $subdir = $confession_id+999-(($confession_id-1)%1000);
	  $confessiondir = "./uploads_confession/$subdir/$confession_id/";
	  return $confessiondir;
	}
  
  // END confession_dir() METHOD
  
  
  
  
  
  
  
  
  //
	// THIS METHOD OUTPUTS THE PATH TO THE confession'S PHOTO OR THE GIVEN NOPHOTO IMAGE
  //
	// INPUT:
  //    $nophoto_image (OPTIONAL) REPRESENTING THE PATH TO AN IMAGE TO OUTPUT IF NO PHOTO EXISTS
  //
	// OUTPUT:
  //    A STRING CONTAINING THE PATH TO THE confession'S PHOTO
  //
  
	function confession_photo($nophoto_image=NULL, $thumb=FALSE)
  {
    if( empty($this->confession_info['confession_photo']) )
      return $nophoto_image;
    
	  $confession_dir = $this->confession_dir($this->confession_info['confession_id']);
	  $confession_photo = $confession_dir.$this->confession_info['confession_photo'];
    if( $thumb )
    {
      $confession_thumb = substr($confession_photo, 0, strrpos($confession_photo, "."))."_thumb".substr($confession_photo, strrpos($confession_photo, "."));
      if( file_exists($confession_thumb) )
        return $confession_thumb;
    }
    
    if( file_exists($confession_photo) )
      return $confession_photo;
    
    return $nophoto_image;
	}
  
  // END confession_photo() METHOD
  
  
  
  
  
  
  
  
  //
	// THIS METHOD UPLOADS AN confession PHOTO ACCORDING TO SPECIFICATIONS AND RETURNS confession PHOTO
  //
	// INPUT:
  //    $photo_name REPRESENTING THE NAME OF THE FILE INPUT
  //
	// OUTPUT:
  //
  
	function confession_photo_upload($photo_name)
  {
	  global $database, $url;
    
	  // SET KEY VARIABLES
	  $file_maxsize = "4194304";
	  $file_exts = explode(",", str_replace(" ", "", strtolower($this->confessionowner_level_info['level_confession_photo_exts'])));
	  $file_types = explode(",", str_replace(" ", "", strtolower("image/jpeg, image/jpg, image/jpe, image/pjpeg, image/pjpg, image/x-jpeg, x-jpg, image/gif, image/x-gif, image/png, image/x-png")));
	  $file_maxwidth = $this->confessionowner_level_info['level_confession_photo_width'];
	  $file_maxheight = $this->confessionowner_level_info['level_confession_photo_height'];
	  $photo_newname = "0_".rand(1000, 9999).".jpg";
	  $file_dest = $this->confession_dir($this->confession_info['confession_id']).$photo_newname;
	  $thumb_dest = substr($file_dest, 0, strrpos($file_dest, "."))."_thumb".substr($file_dest, strrpos($file_dest, "."));
    
	  $new_photo = new se_upload();
	  $new_photo->new_upload($photo_name, $file_maxsize, $file_exts, $file_types, $file_maxwidth, $file_maxheight);
    
	  // UPLOAD AND RESIZE PHOTO IF NO ERROR
	  if( !$new_photo->is_error )
    {
	    // DELETE OLD AVATAR IF EXISTS
	    $this->confession_photo_delete();
      
	    // UPLOAD THUMB
	    $new_photo->upload_thumb($thumb_dest, 200);
      
	    // CHECK IF IMAGE RESIZING IS AVAILABLE, OTHERWISE MOVE UPLOADED IMAGE
	    if( $new_photo->is_image )
	      $new_photo->upload_photo($file_dest);
	    else
	      $new_photo->upload_file($file_dest);
      
	    // UPDATE confession INFO WITH IMAGE IF STILL NO ERROR
	    if( !$new_photo->is_error )
      {
        $sql = "UPDATE se_confessions SET confession_photo='{$photo_newname}' WHERE confession_id='{$this->confession_info['confession_id']}'";
	      $database->database_query($sql);
	      $this->confession_info['confession_photo'] = $photo_newname;
	    }
	  }
    
	  $this->is_error = $new_photo->is_error;
	  $this->error_message = $new_photo->error_message;
	}
  
  // END confession_photo_upload() METHOD
  
  
  
  
  
  
  
  
  //
	// THIS METHOD DELETES A confession PHOTO
  //
	// INPUT: 
  //
	// OUTPUT: 
  //
  
	function confession_photo_delete()
  {
	  global $database;
    
	  $confession_photo = $this->confession_photo();
    
	  if( !empty($confession_photo) )
    {
	    $sql = "UPDATE se_confessions SET confession_photo='' WHERE confession_id='{$this->confession_info['confession_id']}' LIMIT 1";
	    $database->database_query($sql);
	    $this->confession_info['confession_photo'] = "";
	    @unlink($confession_photo);
	  }
	}
  
  // END confession_photo_delete() METHOD
  
  
  
  
  
  
  
  
  //
	// THIS METHOD UPDATES THE confession'S LAST UPDATE DATE
  //
	// INPUT: 
  //
	// OUTPUT: 
  //
  
	function confession_lastupdate()
  {
	  global $database;
    $sql = "UPDATE se_confessions SET confession_dateupdated='".time()."' WHERE confession_id='{$this->confession_info['confession_id']}' LIMIT 1";
	  $database->database_query($sql);
	}
  
  // END confession_lastupdate() METHOD
  
  
  
  
  
  
  
  
  //
	// THIS METHOD UPLOADS MEDIA TO A confession ALBUM
  //
	// INPUT:
  //    $file_name          REPRESENTING THE NAME OF THE FILE INPUT
	//	  $confessionalbum_id REPRESENTING THE ID OF THE confession ALBUM TO UPLOAD THE MEDIA TO
	//	  $space_left         REPRESENTING THE AMOUNT OF SPACE LEFT
  //
	// OUTPUT:
  //
  
	function confession_media_upload($file_name, $confessionalbum_id, &$space_left)
  {
	  global $class_confession, $database, $url;
    
	  // SET KEY VARIABLES
	  $file_maxsize   = $this->confessionowner_level_info['level_confession_album_maxsize'];
	  $file_exts      = explode(",", str_replace(" ", "", strtolower($this->confessionowner_level_info['level_confession_album_exts'])));
	  $file_types     = explode(",", str_replace(" ", "", strtolower($this->confessionowner_level_info['level_confession_album_mimes'])));
	  $file_maxwidth  = $this->confessionowner_level_info['level_confession_album_width'];
	  $file_maxheight = $this->confessionowner_level_info['level_confession_album_height'];
    
	  $new_media = new se_upload();
	  $new_media->new_upload($file_name, $file_maxsize, $file_exts, $file_types, $file_maxwidth, $file_maxheight);
    
	  // UPLOAD AND RESIZE PHOTO IF NO ERROR
	  if( !$new_media->is_error )
    {
	    // INSERT ROW INTO MEDIA TABLE
      $sql = "
        INSERT INTO se_confessionmedia
          (confessionmedia_confessionalbum_id, confessionmedia_date)
        VALUES
          ('{$confessionalbum_id}', '".time()."')
      ";
      
      $database->database_query($sql);
	    $confessionmedia_id = $database->database_insert_id();
      
	    // CHECK IF IMAGE RESIZING IS AVAILABLE, OTHERWISE MOVE UPLOADED IMAGE
      $confession_dir = $this->confession_dir($this->confession_info['confession_id']);
	    if( $new_media->is_image )
      {
	      $file_dest  = "{$confession_dir}{$confessionmedia_id}.jpg";
	      $thumb_dest = "{$confession_dir}{$confessionmedia_id}_thumb.jpg";
        
	      // UPLOAD THUMB
	      $new_media->upload_thumb($thumb_dest, 200);
        
	      // UPLOAD FILE
	      $new_media->upload_photo($file_dest);
	      $file_ext = "jpg";
	      $file_filesize = filesize($file_dest);
	    }
      
      else
      {
	      $file_dest  = "{$confession_dir}{$confessionmedia_id}.{$new_media->file_ext}";
	      $thumb_dest = "{$confession_dir}{$confessionmedia_id}_thumb.jpg";
        
	      if( $new_media->file_ext=='gif' )
	        $new_media->upload_thumb($thumb_dest, 200);
        
	      $new_media->upload_file($file_dest);
	      $file_ext = $new_media->file_ext;
	      $file_filesize = filesize($file_dest);
	    }
      
      // CHECK SPACE LEFT
      if( $space_left!==FALSE && $file_filesize > $space_left)
      {
        $new_media->is_error = 1;
        $new_media->error_message = $class_confession[1].$_FILES[$file_name]['name']; // TODO LANG
      }
      elseif( $space_left!==FALSE )
      {
	      $space_left = $space_left - $file_filesize;
	    }
      
	    // DELETE FROM DATABASE IF ERROR
	    if( $new_media->is_error )
      {
        $sql = "DELETE FROM se_confessionmedia WHERE confessionmedia_id='{$confessionmedia_id}' AND confessionmedia_confessionalbum_id='{$confessionalbum_id}' LIMIT 1";
	      $database->database_query($sql);
	      @unlink($file_dest);
	    }
      
	    // UPDATE ROW IF NO ERROR
      else
      {
	      $sql = "UPDATE se_confessionmedia SET confessionmedia_ext='{$file_ext}', confessionmedia_filesize='{$file_filesize}' WHERE confessionmedia_id='{$confessionmedia_id}' AND confessionmedia_confessionalbum_id='{$confessionalbum_id}' LIMIT 1";
        $database->database_query($sql);
        
        // Update parent row
        $sql = "UPDATE se_confessionalbums SET confessionalbum_totalfiles=confessionalbum_totalfiles+1, confessionalbum_totalspace=confessionalbum_totalspace+'{$file_filesize}' WHERE confessionalbum_id='{$confessionalbum_id}' LIMIT 1";
        $database->database_query($sql);
	    }
	  }
    
	  // RETURN FILE STATS
	  return array(
      'is_error'                  => $new_media->is_error,
			'error_message'             => $new_media->error_message,
			'confessionmedia_id'        => $confessionmedia_id,
			'confessionmedia_ext'       => $file_ext,
			'confessionmedia_filesize'  => $file_filesize
    );
	}
  
  // END confession_media_upload() METHOD
  
  
  
  
  
  
  
  
  //
	// THIS METHOD RETURNS THE SPACE USED
  //
	// INPUT:
  //    $confessionalbum_id (OPTIONAL) REPRESENTING THE ID OF THE ALBUM TO CALCULATE
  //
	// OUTPUT:
  //    AN INTEGER REPRESENTING THE SPACE USED
  //
  
	function confession_media_space($confessionalbum_id=NULL)
  {
	  global $database;
    
    // NEW HANDLING METHOD
    if( !$confessionalbum_id )
    {
      $sql = "
        SELECT
          se_confessionalbums.confessionalbum_totalspace AS total_space
        FROM
          se_confessionalbums
        WHERE
          se_confessionalbums.confessionalbum_id='{$confessionalbum_id}'
        LIMIT
          1
      ";
      
      $resource = $database->database_query($sql);
      
      if( $resource )
      {
        $space_info = $database->database_fetch_assoc($resource);
        return $space_info['total_space'];
      }
    }
    
    // OLD HANDLING METHOD - BACKWARDS COMPATIBILITY
    
	  // BEGIN QUERY
	  $sql = "
      SELECT
        SUM(se_confessionmedia.confessionmedia_filesize) AS total_space
    ";
    
	  // CONTINUE QUERY
	  $sql .= "
      FROM
        se_confessionalbums
      LEFT JOIN
        se_confessionmedia
        ON se_confessionalbums.confessionalbum_id=se_confessionmedia.confessionmedia_confessionalbum_id
    ";
    
	  // ADD WHERE IF NECESSARY
	  if( $this->confession_exists || $confessionalbum_id ) $sql .= "
      WHERE
    ";
    
	  // IF confession EXISTS, SPECIFY confession ID
	  if( $this->confession_exists ) $sql .= "
        se_confessionalbums.confessionalbum_confession_id='{$this->confession_info['confession_id']}'
    ";
    
	  // ADD AND IF NECESSARY
	  if( $this->confession_exists && $confessionalbum_id )
      $sql .= " AND";
    
	  // SPECIFY ALBUM ID IF NECESSARY
	  if( $confessionalbum_id ) $sql .= "
        se_confessionalbums.confessionalbum_id='{$confessionalbum_id}'
    ";
    
	  // GET AND RETURN TOTAL SPACE USED
    $resource = $database->database_query($sql);
	  $space_info = $database->database_fetch_assoc($resource);
	  return $space_info['total_space'];
	}
  
  // END confession_media_space() METHOD
  
  
  
  
  
  
  
  
  //
	// THIS METHOD RETURNS THE NUMBER OF confession MEDIA
  //
	// INPUT:
  //    $confessionalbum_id (OPTIONAL) REPRESENTING THE ID OF THE claconfessionssified ALBUM TO CALCULATE
  //
	// OUTPUT:
  //    AN INTEGER REPRESENTING THE NUMBER OF FILES
  //
  
	function confession_media_total($confessionalbum_id=NULL)
  {
	  global $database;
    
    // NEW HANDLING METHOD
    if( !$confessionalbum_id )
    {
      $sql = "
        SELECT
          se_confessionalbums.confessionalbum_totalfiles AS total_files
        FROM
          se_confessionalbums
        WHERE
          se_confessionalbums.confessionalbum_id='{$confessionalbum_id}'
        LIMIT
          1
      ";
      
      $resource = $database->database_query($sql);
      
      if( $resource )
      {
        $file_info = $database->database_fetch_assoc($resource);
        return $file_info['total_files'];
      }
    }
    
    // OLD HANDLING METHOD - BACKWARDS COMPATIBILITY
    
	  // BEGIN QUERY
	  $sql = "
      SELECT
        COUNT(se_confessionmedia.confessionmedia_id) AS total_files
    ";
    
	  // CONTINUE QUERY
	  $sql .= "
      FROM
        se_confessionalbums
      LEFT JOIN
        se_confessionmedia
        ON se_confessionalbums.confessionalbum_id=se_confessionmedia.confessionmedia_confessionalbum_id
    ";
    
	  // ADD WHERE IF NECESSARY
	  if( $this->confession_exists || $confessionalbum_id ) $sql .= "
      WHERE
    ";
    
	  // IF confession EXISTS, SPECIFY confession ID
	  if( $this->confession_exists ) $sql .= "
        se_confessionalbums.confessionalbum_confession_id='{$this->confession_info['confession_id']}'
    ";
    
	  // ADD AND IF NECESSARY
	  if( $this->confession_exists && $confessionalbum_id )
      $sql .= " AND";
    
	  // SPECIFY ALBUM ID IF NECESSARY
	  if( $confessionalbum_id ) $sql .= "
        se_confessionalbums.confessionalbum_id='{$confessionalbum_id}'
    ";
    
	  // GET AND RETURN TOTAL FILES
    $resource = $database->database_query($sql);
	  $file_info = $database->database_fetch_assoc($resource);
	  return $file_info['total_files'];
	}
  
  // END confession_media_total() METHOD
  
  
  
  
  
  
  
  
  //
	// THIS METHOD RETURNS AN ARRAY OF confession MEDIA
  //
	// INPUT:
  //    $start REPRESENTING THE confession MEDIA TO START WITH
	//	  $limit REPRESENTING THE NUMBER OF confession MEDIA TO RETURN
	//	  $sort_by (OPTIONAL) REPRESENTING THE ORDER BY CLAUSE
	//	  $where (OPTIONAL) REPRESENTING ADDITIONAL THINGS TO INCLUDE IN THE WHERE CLAUSE
  //
	// OUTPUT:
  //    AN ARRAY OF confession MEDIA
  //
  
	function confession_media_list($start, $limit, $sort_by = "confessionmedia_id DESC", $where=NULL, $file_details=FALSE)
  {
	  global $database;
    
    if( !$start ) $start = '0';
    
	  // BEGIN QUERY
	  $sql = "
      SELECT
        se_confessionmedia.*,
        se_confessionalbums.confessionalbum_id,
        se_confessionalbums.confessionalbum_confession_id,
        se_confessionalbums.confessionalbum_title
    ";
    
	  // CONTINUE QUERY
	  $sql .= "
      FROM
        se_confessionmedia
      LEFT JOIN
        se_confessionalbums
        ON se_confessionalbums.confessionalbum_id=se_confessionmedia.confessionmedia_confessionalbum_id
    ";
    
	  // ADD WHERE IF NECESSARY
	  if( $this->confession_exists || !empty($where) ) $sql .= "
      WHERE
    ";
    
	  // IF confession EXISTS, SPECIFY confession ID
	  if( $this->confession_exists ) $sql .= "
        se_confessionalbums.confessionalbum_confession_id='{$this->confession_info['confession_id']}'
    ";
    
	  // ADD AND IF NECESSARY
	  if( $this->confession_exists && !empty($where) )
      $sql .= " AND";
    
	  // ADD ADDITIONAL WHERE CLAUSE
	  if( !empty($where) ) $sql .= "
        $where
    ";
    
	  // ADD GROUP BY, ORDER, AND LIMIT CLAUSE
	  $sql .= "
    /*
      GROUP BY
        confessionmedia_id */
      ORDER BY
        $sort_by
      LIMIT
        $start, $limit
    ";
    
	  // RUN QUERY
    $resource = $database->database_query($sql);
    
	  // GET confession MEDIA INTO AN ARRAY
    $confession_dir = $this->confession_dir($this->confession_info['confession_id']);
	  $confessionmedia_array = array();
	  while( $confessionmedia_info=$database->database_fetch_assoc($resource) )
    {
      $confessionmedia_info['confessionmedia_desc'] = str_replace("<br />", "\r\n", $confessionmedia_info['confessionmedia_desc']);
      
      if( $file_details )
      {
        $mediasize = getimagesize($confession_dir.$confessionmedia_info['confessionmedia_id'].'.'.$confessionmedia_info['confessionmedia_ext']);
        $confessionmedia_info['confessionmedia_dir']  = $confession_dir;
        $confessionmedia_info['confessionmedia_width']  = $mediasize[0];
        $confessionmedia_info['confessionmedia_height'] = $mediasize[1];
        
      }
      
	    $confessionmedia_array[] = $confessionmedia_info;
	  }
    
	  // RETURN ARRAY
	  return $confessionmedia_array;
	}
  
  // END confession_media_list() METHOD
  
  
  
  
  
  
  
  
  //
	// THIS METHOD DELETES SELECTED confession MEDIA
  //
	// INPUT:
  //    $start    REPRESENTING THE confession MEDIA TO START WITH
	//	  $limit    REPRESENTING THE NUMBER OF confession MEDIA TO RETURN
	//	  $sort_by  (OPTIONAL) REPRESENTING THE ORDER BY CLAUSE
	//	  $where    (OPTIONAL) REPRESENTING ADDITIONAL THINGS TO INCLUDE IN THE WHERE CLAUSE
  //
	// OUTPUT:
  //
  
	function confession_media_delete($start, $limit, $sort_by = "confessionmedia_id DESC", $where = "")
  {
	  global $database, $url;
    
	  // BEGIN QUERY
	  $confessionmedia_query = "SELECT se_confessionmedia.*, se_confessionalbums.confessionalbum_id, se_confessionalbums.confessionalbum_confession_id, se_confessionalbums.confessionalbum_title";
    
	  // CONTINUE QUERY
	  $confessionmedia_query .= " FROM se_confessionmedia LEFT JOIN se_confessionalbums ON se_confessionalbums.confessionalbum_id=se_confessionmedia.confessionmedia_confessionalbum_id";
    
	  // ADD WHERE IF NECESSARY
	  if($this->confession_exists != 0 | $where != "") { $confessionmedia_query .= " WHERE"; }
    
	  // IF confession EXISTS, SPECIFY confession ID
	  if($this->confession_exists != 0) { $confessionmedia_query .= " se_confessionalbums.confessionalbum_confession_id='{$this->confession_info['confession_id']}'"; }
    
	  // ADD AND IF NECESSARY
	  if($this->confession_exists != 0 & $where != "") { $confessionmedia_query .= " AND"; }
    
	  // ADD ADDITIONAL WHERE CLAUSE
	  if($where != "") { $confessionmedia_query .= " $where"; }
    
	  // ADD GROUP BY, ORDER, AND LIMIT CLAUSE
	  $confessionmedia_query .= " GROUP BY se_confessionmedia.confessionmedia_id ORDER BY $sort_by LIMIT $start, $limit";
    
	  // RUN QUERY
	  $confessionmedia = $database->database_query($confessionmedia_query);
    
	  // LOOP OVER confession MEDIA
	  $confessionmedia_delete = "";
	  while($confessionmedia_info = $database->database_fetch_assoc($confessionmedia))
    {
	    $var = "delete_confessionmedia_".$confessionmedia_info['confessionmedia_id']; 
	    if($confessionmedia_delete != "") { $confessionmedia_delete .= " OR "; }
	    $confessionmedia_delete .= "confessionmedia_id='$confessionmedia_info[confessionmedia_id]'";
	    $confessionmedia_path = $this->confession_dir($this->confession_info['confession_id']).$confessionmedia_info['confessionmedia_id'].".".$confessionmedia_info['confessionmedia_ext'];
	    if(file_exists($confessionmedia_path)) { @unlink($confessionmedia_path); }
	    $thumb_path = $this->confession_dir($this->confession_info['confession_id']).$confessionmedia_info['confessionmedia_id']."_thumb.".$confessionmedia_info['confessionmedia_ext'];
	    if(file_exists($thumb_path)) { @unlink($thumb_path); }
      
      // Update parent row
      $sql = "UPDATE se_confessionalbums SET confessionalbum_totalfiles=confessionalbum_totalfiles-1, confessionalbum_totalspace=confessionalbum_totalspace-'{$confessionmedia_info['confessionmedia_filesize']}' WHERE confessionalbum_id='{$confessionmedia_info['confessionmedia_confessionalbum_id']}' LIMIT 1";
      $database->database_query($sql);
	  }
    
	  // IF DELETE CLAUSE IS NOT EMPTY, DELETE confession MEDIA
	  if($confessionmedia_delete != "") { $database->database_query("DELETE FROM se_confessionmedia WHERE ($confessionmedia_delete)"); }
	}
  
  // END confession_media_delete() METHOD
}

?>